import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState } from "react";
import { makeStyles } from "@material-ui/styles";
import stringToSequence from "../../string-to-sequence.js";
import Tooltip from "@material-ui/core/Tooltip";
var useStyles = makeStyles({});
export default function Document(_ref) {
  var sequence = _ref.sequence,
      _ref$onHighlightedCha = _ref.onHighlightedChanged,
      onHighlightedChanged = _ref$onHighlightedCha === void 0 ? function () {
    return null;
  } : _ref$onHighlightedCha,
      _ref$onSequenceChange = _ref.onSequenceChange,
      onSequenceChange = _ref$onSequenceChange === void 0 ? function () {
    return null;
  } : _ref$onSequenceChange,
      _ref$nothingHighlight = _ref.nothingHighlighted,
      nothingHighlighted = _ref$nothingHighlight === void 0 ? false : _ref$nothingHighlight,
      _ref$colorLabelMap = _ref.colorLabelMap,
      colorLabelMap = _ref$colorLabelMap === void 0 ? {} : _ref$colorLabelMap;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      mouseDown = _useState2[0],
      changeMouseDown = _useState2[1];

  var _useState3 = useState([null, null]),
      _useState4 = _slicedToArray(_useState3, 2),
      _useState4$ = _slicedToArray(_useState4[0], 2),
      firstSelected = _useState4$[0],
      lastSelected = _useState4$[1],
      changeHighlightedRangeState = _useState4[1];

  var changeHighlightedRange = function changeHighlightedRange(_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        first = _ref3[0],
        last = _ref3[1];

    changeHighlightedRangeState([first, last]);
    var highlightedItems = [];

    for (var i = Math.min(first, last); i <= Math.max(first, last); i++) {
      highlightedItems.push(i);
    }

    onHighlightedChanged(highlightedItems);
  };

  var highlightedItems = [];

  if (!nothingHighlighted && firstSelected !== null && lastSelected !== null) {
    for (var i = Math.min(firstSelected, lastSelected); i <= Math.max(firstSelected, lastSelected); i++) {
      highlightedItems.push(i);
    }
  }

  return /*#__PURE__*/React.createElement("div", {
    onMouseDown: function onMouseDown() {
      return changeMouseDown(true);
    },
    onMouseUp: function onMouseUp() {
      return changeMouseDown(false);
    }
  }, sequence.map(function (seq, i) {
    return /*#__PURE__*/React.createElement("span", _defineProperty({
      key: i,
      onMouseDown: function onMouseDown() {
        if (seq.label) return;
        changeHighlightedRange([i, i]);
      },
      onMouseMove: function onMouseMove() {
        if (seq.label) return;

        if (mouseDown && i !== lastSelected) {
          changeHighlightedRange([firstSelected === null ? i : firstSelected, i]);
        }
      },
      style: seq.label ? {
        display: "inline-flex",
        backgroundColor: seq.color || colorLabelMap[seq.label] || "#333",
        color: "#fff",
        padding: 4,
        margin: 4,
        paddingLeft: 10,
        paddingRight: 10,
        borderRadius: 4,
        userSelect: "none"
      } : {
        display: "inline-flex",
        backgroundColor: seq.text !== " " && highlightedItems.includes(i) ? "#ccc" : "inherit",
        color: "#333",
        marginTop: 4,
        marginBottom: 4,
        paddingTop: 4,
        paddingBottom: 4,
        paddingLeft: 2,
        paddingRight: 2,
        userSelect: "none"
      }
    }, "key", i), seq.label ? /*#__PURE__*/React.createElement(Tooltip, {
      title: seq.label,
      placement: "bottom"
    }, /*#__PURE__*/React.createElement("div", null, seq.text)) : /*#__PURE__*/React.createElement("div", null, seq.text), seq.label && /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        onSequenceChange(sequence.flatMap(function (s) {
          return s !== seq ? s : stringToSequence(s.text);
        }).filter(function (s) {
          return s.text.length > 0;
        }));
      },
      style: {
        display: "inline-flex",
        cursor: "pointer",
        alignSelf: "center",
        fontSize: 11,
        width: 18,
        height: 18,
        alignItems: "center",
        justifyContent: "center",
        marginLeft: 4,
        borderRadius: 9,
        color: "#fff",
        backgroundColor: "rgba(0,0,0,0.2)"
      }
    }, /*#__PURE__*/React.createElement("span", null, "\u2716")));
  }));
}